#include <stdio.h>      /*   /  */
#include <errno.h>      /*                */
#include <sys/types.h>/*  ,   */
#include <signal.h>     /*                   */
#include <sys/wait.h>   /*   wait()           */
#include <fcntl.h>      /*  O_RDONLY              */


#include "tok.h"

#define MAXARGS 100

#define LIM ':'        /*     path */

/*    path    name */
char *execat(char* path,char* name,char* buf)
//    buf
{
 register char *s = buf;
 while(*path && *path != LIM )
 *s++ = *path++;/*   */
 if( s != buf ) *s++ = '/';
 while( *name )
 *s++ = *name++; /*   */
 *s = '\0';
 return ( *path ? ++path /*  LIM */ : NULL );
}

/*        */
void callshell(char* progr,char* args[],char* envp[])
{
 register i; 
 char sh[128], *newav[MAXARGS+2];
 FILE* f; 

 if((f = fopen(progr,"r"))!=0)
 {
  if(fgetc(f)!='#') return; 
  if(fgetc(f)!='!') return;
  fgets(sh,128,f); 
  sh[strlen(sh)-1]=0;
  fclose(f);
 }
 else return;
        newav[0] = "Shellscript";
        newav[1] = progr; 
        for(i=1; args[i]; i++)
 newav[i+1] = args[i];
        newav[i+1] = NULL;
	    
        execve(sh, newav, envp);
}

/*        PATH */
int execvpe(char* progr,char **av,char **envp)
{
 char *path, *cp;
 int try = 1;
 register eacces = 0;
 char fullpath[256]; /*    */

 if((path =(char*) getenv("PATH")) == NULL )
 path = ".:/bin:/usr/bin:/etc";
 /* :      ? */
 cp = strchr(progr, '/') ? "" : path;
 do{     /*    */
    cp = (char*)execat(cp, progr, fullpath);
 retry:
    execve(fullpath, av, envp);
    /*   ,     
     *    .  - . */
    switch( errno ){  /*    ? */
    case ENOEXEC:  /*    */
     callshell(fullpath, av, envp);
     return (1);
    case ETXTBSY:   /*   */
     if( ++try > 5 ) return (-1);
  sleep(try); goto retry;
    case EACCES:  eacces++; break;  /*    */
 
    case ENOMEM:    /*      */
    case E2BIG:
 return (-1);
  }// case
 }while( cp );
 if( eacces ) errno = EACCES;
 return (-1);
}

/*   ,      status. */
void dowait(int chpid)
{
 int ws;
 char b[6]; 
    waitpid( chpid,&ws,WUNTRACED );
    sprintf(b,"%i",WEXITSTATUS(ws)
);
    setvar("status",b);
}

int cmdExec(char* progr,char** av,char** envp)
/*   */
{
 void (*del)(), (*quit)(); //   
 register i, 
          chpid; // # ģ 
 int cr = 0;
 // output   :    
 int cterm = open("/dev/tty",O_RDWR);
 int shpid = getpid();
 
 
 del = signal(SIGINT, SIG_IGN); quit = signal(SIGQUIT, SIG_IGN);
 
 signal(SIGTTOU,SIG_IGN);
 
 if( ! (chpid = fork())) /*  */
 {      /*   () */
   
    if( fone )  setpgrp();	/*    */
    else
    {
	tcsetpgrp(cterm,getpid()); // 
	setpgid(0,0); //  
    }
    
     /*  :  
      *   ,    
      *  main(ac, av, envp) ,    progr.
      * ac  .
 */
 
i=execvpe(progr, av, envp);/*         */
 
   if(i==1) fprintf(stderr,"nsh:  `%s` -   .",av[0]);
   else
    if(errno==ENOENT) fprintf(stderr,"nsh:     `%s`.\n",av[0]);
    else printf("nsh: %s\n",strerror(errno));
    exit(errno); //   
 }
 else  
    if( !fone )
    {
	tcsetpgrp(cterm,chpid);
	setpgid(chpid,chpid); /*     */
	dowait(chpid); /*    ,  ģ  */
	tcsetpgrp(cterm,shpid); //  
    }

    /*   , wait    
     *    */
 
 signal(SIGINT, del); /*       */
 signal(SIGQUIT, quit);
 return chpid;     /*    */
}

