#include <signal.h>     /*                   */
#include <ctype.h>      /*         */
#include <dirent.h>     /*    BSD 4.2 */
#include <pwd.h>        /*   /etc/passwd              */
#include <stdio.h>

#include <sys/types.h>
#include <sys/wait.h>

#include "cmdline.h"
#include "tok.h"
#include "exec.h"

void sigCHILD(int s){  waitpid(-1,NULL,WNOHANG); }

void setcwd() /*     */
{
 char cwd[512];
 getcwd(cwd,512); setenv( "CWD", cwd );
}

static int STACK[100], sp=0;
void push(int p)
{
 if( sp == 100 ) fprintf(stderr,"nsh:    while.\n"),exit(3);
 STACK[sp++] = p;
}
int pop()
{
 if( sp == 0 ) return -1;
 return STACK[--sp];
}

void ERR(char* s)
{
    if( s==NULL ) /*   */
    { /*   ݣ -   */
	if( sp!=0 )
	{
	    if( sp == 1 ) fprintf(stderr,"nsh:   while  .\n");
	    else	  fprintf(stderr,"nsh:   %i  while.\n",sp);
	}
	exit(0);
    }
}

main(int ac,char** av)
{
 char *user = "root";      /*       */
 char *home = "/root";     /*    */
 int uid = getuid(); //  uid
 struct passwd *p = getpwuid(uid); // -  
  uid
 register i=0; // ޣ   
 FILE* f=NULL;
 
 if( ac > 1 )
 {
    f = fopen( av[1],"r" );
    if( !f ){ perror("nsh:    "); return;}
 }
 
 if( p != NULL )
 {
    if(p->pw_name && *p->pw_name ) user = p->pw_name;
    if(               *p->pw_dir ) home = p->pw_dir;
 }
 setenv("USER", user); setenv("HOME", home);
 setvar("home", home); setvar("path", ".:/bin:/sbin:/usr/bin:/usr/sbin");

 setvar("status","0");
 
{ //   .
 sigset_t cldset; // 

    sigemptyset(&cldset); //  SIGTTOU
    sigaddset(&cldset,SIGTTOU); // 
    sigprocmask(SIG_BLOCK,&cldset,0); // 
    
    signal(SIGINT,SIG_IGN);
    signal(SIGCHLD,sigCHILD);
 }
 
 for(i=0; i<MAXARGS; i++) args[i]=NULL;
 
 for(;;)
 {
  unsigned NN = 0, T; // ޣ     
  char *s, *ss; //    

  if( !f ) s = getcmd(); //   
  else
  { 
    T=ftell(f); /* T:=    */
    s = fgets(buf,BUFLEN,f);
    ERR(s);
    buf[strlen(buf)-1]='\0';
    NN++; /*  ޣ  */
  }

  if( s[0]=='\0' ) continue;

  if(ss=(char*)strchr(s,'#')) *ss = '\0'; /*   */
    
  tok(s); // ߣ   
  
  if(argn==0) continue;

  if(strcmp(args[0],"read")==0)
  {
    if( args[1]==NULL )
    {
	fprintf(stderr,"nsh:%2i   \n",NN);
	continue;
    }
    fgets(buf,BUFLEN,stdin); buf[strlen(buf)-1]='\0';
    setvar(args[1],buf);
    continue;
  }
  if(strcmp(args[0],"while")==0)
  { 
    if( !f )
    {
	fprintf(stderr,"nsh: while     Shell-\n");
	continue;
    }
    if( argn!=4 || strcmp(args[1],"(")!=0 || strcmp(args[3],")")!=0 ) 
    fprintf(stderr,"nsh:%2i:   while: while ( var )\n",NN),exit(2);

    if(strcmp(args[2],"0")==0 || strcmp(args[2],"")==0)
    {
     do
     {
      s = fgets(buf,BUFLEN,f);
      ERR(s);
      tok(s);
     }
     while( strcmp(args[0],"end")!=0 );
     continue; 
    }
    push( T );
    continue;
  }
  if(strcmp(args[0],"end")==0)
  {
  int p;
    if( !f )
    {
	fprintf(stderr,"nsh: while     Shell-\n");
	continue;
    }
    p = pop();
    if( p == -1 ) fprintf(stderr,"nsh:%2i:end:  while.\n",NN),exit(1);    
    fseek( f,p,SEEK_SET );
    continue;
  }
  
  if(strcmp(args[0],"exit")==0) puts("nsh:  nsh ۣ"), exit(0);
  if(strcmp(args[0],"pwd")==0)
  {
#define CS 516
   char gdir[CS];
    printf("%s\n",getcwd(gdir,CS)); 
#undef CS
   continue;
  }
  if(strcmp(args[0], "cd" )==0)
  {
   char *d = (argn==1) ? (char*)getenv("HOME"):args[1];
   if(chdir(d) < 0)
 fprintf(stderr,"nsh:     `%s`\n", d );
 else setcwd();
   continue;
  }
  if(strcmp(args[0], "cd.." )==0) { chdir(".."); setcwd();
 continue;}
  if(strcmp(args[0], "echo" )==0)
  {
   for(i=1; i<argn; i++)  printf("%s%c",args[i],argn==i+1 ? '\n':' ');
   continue;
  } 
  
  if(strcmp(args[0], "set" )==0)   
  {
   if( argn != 4 ) fprintf(stderr,"nsh:  set A = B\n");
   else  
   {
    if( strcmp(args[2],"=")!=0 ) fprintf(stderr,"nsh:  set A = B\n");
    else setvar( args[1], args[3] ); //   
   }
   continue;
  }
  if(strcmp(args[0], "unset" )==0) 
  {
   if(args[1]) unsetvar(args[1]);
   continue;
  }  
  if(strcmp(args[0],"getenv")==0) //  
  {
   for(i=0; environ[i]; i++) printf("%s\n",environ[i]);
   continue; 
  }
  if(strcmp(args[0],"setenv")==0)
  { /*    */
   if(argn>1) setenv(args[1],(char*)strdup(findvar(args[1])));
   continue;
  }

   cmdExec(args[0],args,environ); //   
 }

}
